package no.siriuslabs.geoassistant.db;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToOne;
import javax.persistence.Table;

/**
 * Entity class used to persist information about a final configuration into a database.
 * The entity holds the final Maude configuration generated by the simulation and a reference to the ComputationRun it belongs to.
 */
@Entity
@Table(name = "final_configuration")
public class FinalConfiguration {

	/**
	 * Unique technical ID of the final configuration.
	 */
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private long id;

	/**
	 * Reference to the ComputationRun this entity belongs to.
	 */
	@OneToOne
	private ComputationRun computationRun;

	/**
	 * The final Maude configuration generated by the simulation.
	 */
	@Column(name = "final_config", columnDefinition = "VARCHAR", nullable = false)
	private String finalConfig;

	public ComputationRun getComputationRun() {
		return computationRun;
	}

	public void setComputationRun(ComputationRun computationRun) {
		this.computationRun = computationRun;
	}

	public String getFinalConfig() {
		return finalConfig;
	}

	public void setFinalConfig(String finalConfig) {
		this.finalConfig = finalConfig;
	}
}
